package org.archiviststoolkit.plugin.dev;

import org.java.plugin.Plugin;
import org.archiviststoolkit.plugin.ATPlugin;
import org.archiviststoolkit.ApplicationFrame;
import org.archiviststoolkit.editor.ArchDescriptionFields;
import org.archiviststoolkit.swing.InfiniteProgressPanel;
import org.archiviststoolkit.mydomain.DomainObject;

import javax.swing.*;
import java.awt.*;
import java.util.HashMap;

/**
 * Archivists' Toolkit(TM) Copyright  2005-2007 Regents of the University of California, New York University, & Five Colleges, Inc.
 * All rights reserved.
 * <p/>
 * This software is free. You can redistribute it and / or modify it under the terms of the Educational Community License (ECL)
 * version 1.0 (http://www.opensource.org/licenses/ecl1.php)
 * <p/>
 * This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the ECL license for more details about permissions and limitations.
 * <p/>
 * <p/>
 * Archivists' Toolkit(TM)
 * http://www.archiviststoolkit.org
 * info@archiviststoolkit.org
 * <p/>
 *
 * This is a simple class used to test certain functionality of the AT
 * by the development team
 *
 * Created by IntelliJ IDEA.
 *
 * @author: Nathan Stevens
 * Date: Mar 3, 2009
 * Time: 2:35:12 PM
 */
public class ATDevPlugin extends Plugin implements ATPlugin {
    protected ApplicationFrame mainFrame;
    private ATDevPluginFrame pluginFrame;

    // get the category this plugin belongs to
    public String getCategory() {
        return ATPlugin.DEFAULT_CATEGORY;
    }

    // get the name of this plugin
    public String getName() {
        return "AT Dev Plugin";
    }

    // Method to set the main frame
    public void setApplicationFrame(ApplicationFrame mainFrame) {
        this.mainFrame = mainFrame;
    }

    // Method that display the window
    public void showPlugin() {
        pluginFrame = new ATDevPluginFrame();
        pluginFrame.pack();
        pluginFrame.setVisible(true);
        pluginFrame.setApplicationFrame(mainFrame);
    }

    // method to display a plugin that needs a parent frame
    public void showPlugin(Frame owner) { }

    // method to display a plugin that needs a parent dialog
    public void showPlugin(Dialog owner) { }

    // Method to return any panels for embedded plugins
    public HashMap getEmbeddedPanels() {
        return null;
    }

    public void setEditorField(ArchDescriptionFields editorField) {  }

    /**
     * Method to set the domain object for this plugin
     */
    public void setModel(DomainObject domainObject, InfiniteProgressPanel monitor) { }

    /**
     * Method to get the table from which the record was selected
     * @param callingTable The table containing the record
     */
    public void setCallingTable(JTable callingTable) { }

    /**
     * Method to set the selected row of the calling table
     * @param selectedRow
     */
    public void setSelectedRow(int selectedRow) { }

    /**
     * Method to set the current record number along with the total number of records
     * @param recordNumber The current record number
     * @param totalRecords The total number of records
     */
    public void setRecordPositionText(int recordNumber, int totalRecords) { }

    // Method to do a specific task in the plugin
    public void doTask(String task) { }

    // Method to get the list of specific task the plugin can perform
    public String[] getTaskList() {
        return null;
    }

    // Method to return the editor type for this plugin
    public String getEditorType() {
        return "";
    }

    // code that is executed when plugin starts. not used here
    protected void doStart()  { }

    // code that is executed after plugin stops. not used here
    protected void doStop()  { }

    // main method for testing only
    public static void main(String[] args) {
        ATDevPlugin devPlugin = new ATDevPlugin();
        devPlugin.showPlugin();
    }
}
