/*
 * Created by JFormDesigner on Tue Mar 03 14:43:21 EST 2009
 */

package org.archiviststoolkit.plugin.dev;

import java.awt.*;
import java.awt.event.*;
import java.util.Collection;
import javax.swing.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;
import org.archiviststoolkit.ApplicationFrame;
import org.archiviststoolkit.plugin.ATPluginUtils;
import org.archiviststoolkit.dialog.*;
import org.archiviststoolkit.mydomain.DomainTableWorkSurface;
import org.archiviststoolkit.mydomain.DomainEditor;
import org.archiviststoolkit.mydomain.DomainObject;
import org.archiviststoolkit.model.*;

/**
 * @author Nathan Stevens
 */
public class ATDevPluginFrame extends JFrame {
    private ApplicationFrame mainFrame; // the main AT application frame
    private DomainTableWorkSurface worksurface; // the currently selected worksurface
    private DomainEditor dialog; // the current dialog for the worksurface
    private DomainObject record; // the current domain object
    private boolean readRecord = true; // used to stop the loop for reading the record

    public ATDevPluginFrame() {
        super("AT Dev Plugin 1.0 3/13/2009");
        initComponents();
    }

    // close this window
    private void okButtonActionPerformed(ActionEvent e) {
        setVisible(false);
        dispose();
    }

    // Method to clear the console for read record
    private void clearConsole1(ActionEvent e) {
        textArea1.setText("");
    }

    // Method to start thread that reads in the records in a loop
    private void startReadingRecords(ActionEvent e) {
        readRecord = true; //set this to true

        Thread performer = new Thread(new Runnable() {
            public void run() {
                // alert user text has started
                textArea1.setText("Starting Reading Records ...\n\n");

                int count = 1; // the current count of the record opened
                Collection results = worksurface.getResultSet();
                int max = results.size() - 1;
                int selectedRow = worksurface.getSelectedRow();

                while(readRecord) {
                    textArea1.append("Record Opened " + count + " Time(s)\n");
                    count++;

                    // open the record now
                    worksurface.onUpdate();

                    try {
                        int wait1 = Integer.parseInt(textField1.getText())*1000;
                        int wait2 = Integer.parseInt(textField2.getText())*1000;

                        Thread.sleep(wait1); // wait a period of time
                        // close the dialog
                        dialog.closeAndNoSave();

                        Thread.sleep(wait2); // wait a period of time

                        // move to the next entry in the field
                        selectedRow++;
                        if(selectedRow > max) {
                            selectedRow = 0;
                        }

                        // interate until we find a record that is not locked
                        while(worksurface.setSelectedRow(selectedRow)) {
                            selectedRow++;
                        }

                        Thread.sleep(2000); // wait 2 seconds

                    } catch(InterruptedException ie) {
                        readRecord = false;
                    }
                }

                // indicate the testing was stop
                textArea1.append("\n\nReading Records Stoped ...");
            }
        });
        performer.start();
    }

    // Method to stop reading records
    private void stopReadingRecords(ActionEvent e) {
        readRecord = false;
    }

    private void setCurrentRecord(ActionEvent e) {
        record = worksurface.getCurrentDomainObject();
    }

    // test the pluginUtil validation
    private void validateResourceRecord() {
        Resources record = new Resources();
        ATPluginUtils.validateRecord(this, record);
    }

    private void initComponents() {
        // JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
        // Generated using JFormDesigner non-commercial license
        dialogPane = new JPanel();
        contentPanel = new JPanel();
        tabbedPane1 = new JTabbedPane();
        panel1 = new JPanel();
        label1 = new JLabel();
        label2 = new JLabel();
        textField1 = new JTextField();
        label3 = new JLabel();
        textField2 = new JTextField();
        label4 = new JLabel();
        button2 = new JButton();
        button3 = new JButton();
        button4 = new JButton();
        scrollPane1 = new JScrollPane();
        textArea1 = new JTextArea();
        panel2 = new JPanel();
        label5 = new JLabel();
        panel3 = new ATDebugEditorFields();
        panel4 = new JPanel();
        label6 = new JLabel();
        button5 = new JButton();
        buttonBar = new JPanel();
        button1 = new JButton();
        okButton = new JButton();
        CellConstraints cc = new CellConstraints();

        //======== this ========
        Container contentPane = getContentPane();
        contentPane.setLayout(new BorderLayout());

        //======== dialogPane ========
        {
            dialogPane.setBorder(Borders.DIALOG_BORDER);
            dialogPane.setLayout(new BorderLayout());

            //======== contentPanel ========
            {
                contentPanel.setLayout(new FormLayout(
                    "default",
                    "default"));

                //======== tabbedPane1 ========
                {

                    //======== panel1 ========
                    {
                        panel1.setLayout(new FormLayout(
                            new ColumnSpec[] {
                                FormFactory.DEFAULT_COLSPEC,
                                FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                                FormFactory.DEFAULT_COLSPEC,
                                FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                                new ColumnSpec(Sizes.dluX(20)),
                                FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                                new ColumnSpec(Sizes.DLUX14),
                                FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                                new ColumnSpec(Sizes.dluX(34)),
                                FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                                new ColumnSpec(Sizes.dluX(81))
                            },
                            new RowSpec[] {
                                FormFactory.DEFAULT_ROWSPEC,
                                FormFactory.LINE_GAP_ROWSPEC,
                                FormFactory.DEFAULT_ROWSPEC,
                                FormFactory.LINE_GAP_ROWSPEC,
                                FormFactory.DEFAULT_ROWSPEC,
                                FormFactory.LINE_GAP_ROWSPEC,
                                new RowSpec(RowSpec.FILL, Sizes.dluY(52), FormSpec.DEFAULT_GROW)
                            }));

                        //---- label1 ----
                        label1.setText("Module to open all the records in the list one by one");
                        label1.setForeground(Color.blue);
                        panel1.add(label1, cc.xywh(1, 1, 11, 1));

                        //---- label2 ----
                        label2.setText("Open for");
                        panel1.add(label2, cc.xy(1, 3));

                        //---- textField1 ----
                        textField1.setColumns(2);
                        textField1.setText("15");
                        panel1.add(textField1, cc.xy(3, 3));

                        //---- label3 ----
                        label3.setText(" Wait for ");
                        panel1.add(label3, cc.xywh(5, 3, 3, 1));

                        //---- textField2 ----
                        textField2.setColumns(2);
                        textField2.setText("5");
                        panel1.add(textField2, cc.xy(9, 3));

                        //---- label4 ----
                        label4.setText("seconds after close");
                        panel1.add(label4, cc.xy(11, 3));

                        //---- button2 ----
                        button2.setText("Start");
                        button2.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                startReadingRecords(e);
                            }
                        });
                        panel1.add(button2, cc.xy(1, 5));

                        //---- button3 ----
                        button3.setText("Stop");
                        button3.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                stopReadingRecords(e);
                            }
                        });
                        panel1.add(button3, cc.xy(3, 5));

                        //---- button4 ----
                        button4.setText("Clear Console");
                        button4.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                clearConsole1(e);
                            }
                        });
                        panel1.add(button4, cc.xy(11, 5));

                        //======== scrollPane1 ========
                        {
                            scrollPane1.setViewportView(textArea1);
                        }
                        panel1.add(scrollPane1, cc.xywh(1, 7, 11, 1));
                    }
                    tabbedPane1.addTab("Read Record", panel1);


                    //======== panel2 ========
                    {
                        panel2.setLayout(new BorderLayout());

                        //---- label5 ----
                        label5.setText("Module to test the validation of textfield ISO dates");
                        label5.setForeground(Color.blue);
                        panel2.add(label5, BorderLayout.NORTH);
                        panel2.add(panel3, BorderLayout.CENTER);
                    }
                    tabbedPane1.addTab("ISO Date Validation", panel2);


                    //======== panel4 ========
                    {
                        panel4.setLayout(new FormLayout(
                            new ColumnSpec[] {
                                FormFactory.DEFAULT_COLSPEC,
                                FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                                FormFactory.DEFAULT_COLSPEC
                            },
                            new RowSpec[] {
                                FormFactory.DEFAULT_ROWSPEC,
                                FormFactory.LINE_GAP_ROWSPEC,
                                FormFactory.DEFAULT_ROWSPEC,
                                FormFactory.LINE_GAP_ROWSPEC,
                                FormFactory.DEFAULT_ROWSPEC
                            }));

                        //---- label6 ----
                        label6.setText("Validate Resource Record");
                        panel4.add(label6, cc.xy(1, 1));

                        //---- button5 ----
                        button5.setText("Validate");
                        button5.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                validateResourceRecord();
                            }
                        });
                        panel4.add(button5, cc.xy(3, 1));
                    }
                    tabbedPane1.addTab("Record Validation", panel4);

                }
                contentPanel.add(tabbedPane1, cc.xy(1, 1));
            }
            dialogPane.add(contentPanel, BorderLayout.CENTER);

            //======== buttonBar ========
            {
                buttonBar.setBorder(Borders.BUTTON_BAR_GAP_BORDER);
                buttonBar.setLayout(new FormLayout(
                    new ColumnSpec[] {
                        FormFactory.GLUE_COLSPEC,
                        FormFactory.DEFAULT_COLSPEC,
                        FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                        FormFactory.BUTTON_COLSPEC
                    },
                    RowSpec.decodeSpecs("pref")));

                //---- button1 ----
                button1.setText("Set Current Record");
                button1.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        setCurrentRecord(e);
                    }
                });
                buttonBar.add(button1, cc.xy(2, 1));

                //---- okButton ----
                okButton.setText("OK");
                okButton.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        okButtonActionPerformed(e);
                    }
                });
                buttonBar.add(okButton, cc.xy(4, 1));
            }
            dialogPane.add(buttonBar, BorderLayout.SOUTH);
        }
        contentPane.add(dialogPane, BorderLayout.CENTER);
        pack();
        setLocationRelativeTo(getOwner());
        // JFormDesigner - End of component initialization  //GEN-END:initComponents
    }

    // JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
    // Generated using JFormDesigner non-commercial license
    private JPanel dialogPane;
    private JPanel contentPanel;
    private JTabbedPane tabbedPane1;
    private JPanel panel1;
    private JLabel label1;
    private JLabel label2;
    private JTextField textField1;
    private JLabel label3;
    private JTextField textField2;
    private JLabel label4;
    private JButton button2;
    private JButton button3;
    private JButton button4;
    private JScrollPane scrollPane1;
    private JTextArea textArea1;
    private JPanel panel2;
    private JLabel label5;
    private ATDebugEditorFields panel3;
    private JPanel panel4;
    private JLabel label6;
    private JButton button5;
    private JPanel buttonBar;
    private JButton button1;
    private JButton okButton;
    // JFormDesigner - End of variables declaration  //GEN-END:variables

    public void setApplicationFrame(ApplicationFrame mainFrame) {
        this.mainFrame = mainFrame;
        if(mainFrame != null) {
            worksurface = mainFrame.getWorkSurfaceContainer().getCurrentWorkSurface();
            dialog = worksurface.getDomainEditor();
        }
    }
}
